/*
 * Timer - a simple timer app
 * Copyright (C) 2005 Scott Lawrence
 *
 */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

/* 2005-05-08 - initial version:  (Taylor Helsper)
 *		- basic version done.
 *		- Text for timer
 *		- Center button pauses/starts timer
 *      - Play/Pause Button sets timer abck to zero
 * 2005-05-22 - Version 1.1 Complete
 *      - Made text larger and centered
 *      - Now accurate to tenths of seconds
 *      - Pausable on tenths of seconds
 */

/* Thanks to Scott Lawrence for writing the clock program which I modified and 
 * made into a timer.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#define PZ_COMPAT
#include "pz.h"
//#include "mlist.h"
//#include "vectorfont.h"

static PzModule *module;
static GR_TIMER_ID 	Lost_timer = 0;
static GR_GC_ID		Lost_gc = 0;
static GR_WINDOW_ID	Lost_bufwid = 0;
static GR_WINDOW_ID	Lost_wid = 0;
static GR_SCREEN_INFO	Lost_screen_info;
static int 		Lost_height = 0;
static int w, h, bpp;
/* The monster is black smoke */

int Lost_seconds = 0;
int Lost_minutes = 108;
int Lost_intpaused = 1;
int Lost_tensseconds = 0;
#define str ":>4 8 15 16 23 42 []"
#define Lost_DISPLAY 	(0)
#define Lost_MINUTES	(2)
#define Lost_SECONDS	(3)
#define Lost_MAX	(3)


static void Lost_do_draw( void )
{
	char s[30];
	
    /* start clear */
    GrSetGCForeground( Lost_gc, BLACK );
    GrFillRect( Lost_bufwid, Lost_gc, 0, 0,
                Lost_screen_info.cols, Lost_height );

    /* copy the buffer into place */
    GrCopyArea( Lost_wid, Lost_gc, 0, 0,
                Lost_screen_info.cols,
                (screen_info.rows - (HEADER_TOPLINE + 1)),
                Lost_bufwid, 0, 0, MWROP_SRCCOPY);

	GrSetGCForeground( Lost_gc, RED );
/* The others aren't simple people... */
	if ((Lost_seconds < 10) & (Lost_minutes < 10)) {
			sprintf( s, "0%i 0%i", Lost_minutes, Lost_seconds );
	}
	else if ((Lost_seconds < 10) & (Lost_minutes >= 10)) {
			sprintf( s, "%i 0%i", Lost_minutes, Lost_seconds );
	}
	else if ((Lost_seconds >= 10) & (Lost_minutes < 10)) {
			sprintf( s, "0%i %i", Lost_minutes, Lost_seconds );
	}
	else {
			sprintf( s, "%i %i", Lost_minutes, Lost_seconds );
	}

	w =ttk_screen->w; 
	h =ttk_screen->h;
	bpp =ttk_screen->bpp;

	// Draws string with vectorfont                                       x   y
	vector_render_string( Lost_wid, Lost_gc, s, 1, 5, w * .25 , h * .25);
	GrSetGCForeground( Lost_gc, GREEN );
	vector_render_string( Lost_wid, Lost_gc, str, 1, 2, w * .1 , h * .8);
// Increments counters
	if (Lost_intpaused > 0) {
			Lost_tensseconds++;
	}
/* Sun gets pregnant eventhough Jin is infertile*/
	// Change values when limit is reached
	if (Lost_tensseconds==10) {
			Lost_seconds--;
			Lost_tensseconds = 0;
	}

	if (Lost_seconds==0) {
			Lost_seconds = 59;
			Lost_minutes--;
	}

	if (Lost_minutes == 0 && Lost_seconds==0) {
			system("/bin/reboot");
	}

/* The button Really destroys the world */
}

/* Desmod comes back in the season 2 finale, drunk */
static void Lost_exit( void ) 
{
	GrDestroyTimer( Lost_timer );
	GrDestroyGC( Lost_gc );
	pz_close_window( Lost_wid );
	GrDestroyWindow( Lost_bufwid );
}


/* event handler */
static int Lost_handle_event (GR_EVENT *event)
{
	switch( event->type )
	{
	    case GR_EVENT_TYPE_TIMER:
/* Henry Gale, or whoever, is the leader of the others */
		Lost_do_draw();
		break;

	    case GR_EVENT_TYPE_KEY_DOWN:
		switch (event->keystroke.ch)
		{
		case 'd': // Play/pause button
			if (Lost_minutes < 4) {
			Lost_seconds = 0;
			Lost_minutes = 108;
			};
		    break;
		case 'm': // Menu button
		    Lost_exit();
		    break;
		default:
		    break;
		} // keystroke
/* Michael shoots Libby and Ana Lucia and sells his friends out for Walt */
		break;   // key down

	} // event type

	return 1;
}

static void draw_header()
{
	pz_draw_header ("Lost Counter");
}

/* the main entry point */
void new_Lost_window(void)
{
	/* Init randomizer */
	srand(time(NULL));

	GrGetScreenInfo(&Lost_screen_info);

	Lost_gc = GrNewGC();
        GrSetGCUseBackground(Lost_gc, GR_FALSE);
        GrSetGCForeground(Lost_gc, BLACK);

	Lost_height = (screen_info.rows - (HEADER_TOPLINE + 1));

	Lost_wid = pz_new_window( 0, HEADER_TOPLINE + 1,
		    screen_info.cols, Lost_height,
		    Lost_do_draw, Lost_handle_event );

	Lost_bufwid = GrNewPixmap( screen_info.cols, Lost_height, NULL );
	draw_header()
        GrSelectEvents( Lost_wid, GR_EVENT_MASK_TIMER
					| GR_EVENT_MASK_EXPOSURE
					| GR_EVENT_MASK_KEY_UP
					| GR_EVENT_MASK_KEY_DOWN );

	Lost_timer = GrCreateTimer( Lost_wid, 100 ); /* 1/10 sec. */

	GrMapWindow( Lost_wid );
}

PZ_SIMPLE_MOD("lost", new_Lost_window, "/Extras/Demos/Lost Countdown") 

